#pragma once

// RobotAPI
#include <atomic>
#include <RobotAPI/interface/units/PlatformUnitInterface.h>

// Navigation
#include <Navigation/libraries/core/types.h>
#include <Navigation/libraries/server/execution/ExecutorInterface.h>


namespace armarx::nav::server
{

    class PlatformUnitExecutor : virtual public ExecutorInterface
    {

    public:

        PlatformUnitExecutor(PlatformUnitInterfacePrx platformUnit);
        ~PlatformUnitExecutor() override;

        void move(const core::Twist& twist) override;

        void disableAndStop();
        void enable();

    private:

        PlatformUnitInterfacePrx platformUnit;

        std::atomic_bool enabled{true};

    };

}  // namespace armarx::nav::server
